CodeForces 39 E.What Has Dirichlet Got to Do with That?(博弈论+dfs)

125 篇文章 0 订阅
38 篇文章 1 订阅

Description

初始状态有 a a 个不同的盒子和b个不同的物品, Stas S t a s Masha M a s h a 两个人轮流操作, Stas S t a s 先手,每步可以选择加一个不同于已有盒子的盒子或者不同于已有物品的物品,如果在某人操作过后,把这些物品放入这些盒子里的方案数不小于 n n 则该人失败,问谁赢

Input

三个整数a,b,n(1a104,1b30,2n109)

Output

如果是平局则输出 Missing M i s s i n g ,否则输出失败者

Sample Input

2 2 10

Sample Output

Masha

Solution

方案数为 ab a b ,两种后继状态即为 (a+1)b,ab+1 ( a + 1 ) b , a b + 1

如果 a>1,b>1 a > 1 , b > 1 ,显然不会出现平局的情况,在很少步操作后就会出现败者,此时直接记忆化搜索即可

如果 a=1 a = 1 ,如果 2b<n 2 b < n 则先手进行 aa+1 a → a + 1 的操作有赢的可能,否则双方都选择 bb+1 b → b + 1 的操作,必然平局

如果 b=1 b = 1 ,此时如果 a2n a 2 ≥ n ,双方都不会选择 bb+1 b → b + 1 的操作,每步只能 aa+1 a → a + 1 ,此时只和 na n − a 的奇偶性有关,为奇数则先手败,否则后手败,如果 a<n2 a < n 2 则先手进行 bb+1 b → b + 1 的操作也有机会赢

Code

#include<cstdio>
#include<iostream>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<vector>
#include<queue>
#include<map>
#include<set>
#include<ctime>
using namespace std;
typedef long long ll;
typedef pair<int,int>P;
const int INF=0x3f3f3f3f,maxn=100001;
int a,b,n;
map<P,int>m;
bool check(int x,int y)
{
    ll ans=1;
    for(int i=1;i<=y;i++)
    {
        ans*=(ll)x;
        if(ans>=n)return 1;
    }
    return 0;
}
int dfs(int x,int y)
{
    if(m.find(P(x,y))!=m.end())return m[P(x,y)];
    if(x==1&&check(2,y))return m[P(x,y)]=2;
    if(y==1&&check(x,2))
    {
        if((n-x)&1)return m[P(x,y)]=0;
        else return m[P(x,y)]=1; 
    }
    if(check(x,y))return m[P(x,y)]=1;
    int t1=check(x+1,y),t2=check(x,y+1);
    if(t1&&t2)return m[P(x,y)]=0;
    if(t1==0)t1=dfs(x+1,y);
    if(t2==0)t2=dfs(x,y+1);
    if(t1==0||t2==0)return m[P(x,y)]=1;//后继有必败态
    //否则先手必败或平局,优先平局 
    if(t1==2||t2==2)return m[P(x,y)]=2;
    return m[P(x,y)]=0; 
}
int main()
{
    while(~scanf("%d%d%d",&a,&b,&n))
    {
        m.clear();
        int ans=dfs(a,b);
        if(ans==0)printf("Stas\n");
        else if(ans==1)printf("Masha\n");
        else printf("Missing\n");
    }
    return 0;
}
题目描述 给定一棵 $n$ 个节点的树,每个节点都有一个权值 $w_i$。你需要删去树上的一些边,使得剩下的每个连通块中,所有节点的权值之和不超过 $k$。 求最多能删去多少条边。 输入格式 第一行包含两个整数 $n,k$。 第二行包含 $n$ 个整数 $w_1,w_2,\cdots,w_n$。 接下来 $n-1$ 行,每行包含两个整数 $a,b$,表示节点 $a$ 和节点 $b$ 之间有一条边。 输出格式 输出一个整数,表示最多能删去的边数。 数据范围 $1\le n \le 10^5$ $1 \le k,w_i \le 10^9$ 输入样例1: 5 6 2 3 1 5 4 1 2 1 3 2 4 2 5 输出样例1: 2 输入样例2: 5 3 2 3 1 5 4 1 2 1 3 2 4 2 5 输出样例2: 0 算法1 (dfs) $O(n)$ 首先我们可以想到暴力的做法,即对于每个连通块,暴力枚举删去哪些边,尝试得到最多的删边数。那么如何求解一个连通块内的所有节点权值之和呢?我们可以使用 DFS 遍历树,对于每个节点,求出其子树内所有节点的权值之和,那么以该节点为根的子树内的所有节点权值之和就是该节点自身的权值加上其所有子节点的权值之和。 对于每个连通块,我们枚举该连通块内任意两个节点 $x,y$。如果 $x$ 与 $y$ 之间的路径上的所有边都被删去了,那么 $x$ 和 $y$ 就会分别成为两个新的连通块,这两个新的连通块内所有节点的权值之和都不超过 $k$。因此我们只需要枚举所有的 $x,y$ 对,对于每个 $x,y$ 对尝试删去它们之间的路径上的所有边,看是否能够让 $x$ 和 $y$ 成为两个新的连通块,进而更新答案即可。 时间复杂度 参考文献 python3 代码 算法2 (暴力枚举) $O(n^2)$ blablabla 时间复杂度 参考文献 C++ 代码 class Solution { public: const int N = 1e5+10; int n,k; int h[N],e[N<<1],ne[N<<1],idx; int w[N]; int sum[N]; bool st[N]; int res; void add(int a,int b) { e[idx] = b,ne[idx] = h[a],h[a] = idx++; } void dfs(int u,int father) { sum[u] = w[u]; for(int i=h[u];~i;i=ne[i]) { int j = e[i]; if(j == father) continue; dfs(j,u); sum[u] += sum[j]; } } void dfs2(int u,int father) { for(int i=h[u];~i;i=ne[i]) { int j = e[i]; if(j == father) continue; dfs2(j,u); if(sum[j] <= k) res++; else if(sum[u] - sum[j] <= k) res++; } } void solve() { cin >> n >> k; memset(h,-1,sizeof(h)); for(int i=1;i<=n;i++) cin >> w[i]; for(int i=1;i<n;i++) { int a,b; cin >> a >> b; add(a,b); add(b,a); } dfs(1,-1); dfs2(1,-1); cout << res << endl; } }; int main() { Solution().solve(); return 0; }
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值